(function(){
	'use strict'	
    angular.module('Corporativo.Core').directive('modal', modal);

    function modal(ModalServices,$timeout){
		return{
			scope:{},
			restrict:'AE',
			link:function(scope, element, attrs){
				function notDeslizable(){
					let ex=['datos_generales_clientes'];
					for (let i=0; i<ex.length; i++){
						if (window.location.pathname.lastIndexOf(ex[i])>0){
							return true;
						}
					}
					return false;
				}
				if(attrs.deslizable=='true' && !notDeslizable()){ 
					element.addClass("custom-modal");
					$('#' + attrs.id).children('.modal-dialog').draggable({
						handle: ".modal-header",
						opacity: 0.85,
						addClasses: false,
						containment: [
							-( ($('#' + attrs.id).width()/2)+$('#' + attrs.id).offset().left ),
							-( 100 ),
							( window.screen.width-($('#' + attrs.id).width()/2)),
							(window.screen.height-250)
							],
						stop: function (evt, ui){
    						$(this).parent().offset({top:ui.offset.top, left:ui.offset.left});
    						$(this).css('top',0).css('left', 0);
						}
					});
					window.onresize = function (e) {
						$('#' + attrs.id).children('.modal-dialog').draggable(
							"option", "containment",[
								-( ($('#' + attrs.id).width()/2)+$('#' + attrs.id).offset().left ),
								-( 100 ),
								( window.screen.width-($('#' + attrs.id).width()/2)),
								(window.screen.height-250)
							]
						);
					}
				}	
				if (!attrs.id) {
                    return;
                }                
                scope.Abrir = function() {                	                	
                	$timeout(function() {          		
                		$('#'+attrs.id).modal({ backdrop: 'static', keyboard: false });                 		
						$('#'+attrs.id).on('shown.bs.modal', () => {
							if(attrs.deslizable && attrs.deslizable == 'true' && !notDeslizable()) {
								$('.modal-backdrop.show').css('opacity', '0'); 
								$('.modal-backdrop').css('display', 'none');
							}
						});	
						if(attrs.deslizable && attrs.deslizable == 'true' && !notDeslizable()){$('#'+attrs.id).removeClass("modal");
						}
						if(attrs.id == "modalgenerico") { $('#'+attrs.id).appendTo("body") }
                	}, 250);                    
                }
                
                scope.Cerrar = function() {                	
                	$timeout(function() {$('#'+attrs.id).modal("hide");}, 50);
                }
                let modal = {
                    id: attrs.id,
                    abrir: scope.Abrir,
                    cerrar: scope.Cerrar
                };
                ModalServices.AgregarModal(modal);
			}
		}
	}
})()